-- SorcererHelper
-- Gently reminds you to summon your minion and alerts you when Crystal Fragments procs.
-- Author: stjobe
-- LibAddonMenu courtesy of Seerah: http://www.esoui.com/downloads/info7-LibAddonMenu.html
-- Animation guidance courtesy of acies: http://www.esoui.com/forums/showthread.php?t=1191
-- Many thanks to the rest of the ESOUI community for their (knowing or unknowing) help.

local SH = {}
SH.SV = {}
SH.Abilities = {}
SH.Icons = {}
SH.Slotted = {}
SH.Buffs = {}
SH.BuffBar = 0
SH.AlertBar = 0
SH.CFCost = 0
SH.CFSlot = 0
SH.CFProc = false
SH.CFTimer = 8
SH.SurgeProc = false
SH.SurgeTimer = 0
SH.SurgeSlot = 0
SH.LFProc = false
SH.LFTimer = 0
SH.LFSlot = 0
SH.LFMorphed = false
SH.EHProc = false
SH.EHTimer = 0
SH.EHSlot = 0
SH.CurseProc = false
SH.CurseMorphed = false
SH.CurseTimer = 0
SH.CurseSlot = 0
SH.ScanKeys = false
SH.ScanKeysRunning = false
SH.CustomEasing = ZO_GenerateCubicBezierEase(.05, 1.85, .75, .75)

SH.Defaults = {
	BBx = 400,
	BBy = 43,
	ABx = 402,
	ABy = 80,
	ShowMove = false,
	ShowSummons = true,
	ShowProc = true,
	ShowLight = true,
	ShowSurge = true,
	ShowLightningForm = true,
	ShowExpertHunter = true,
	ShowBoundArmor = true,
	ShowCurse = true,
	HideInMenus = false,
}
-----------------------------------------------------
function SH.CreateBuffWindow(name, px)
	local tlw = WINDOW_MANAGER:CreateTopLevelWindow("SorcererHelper"..name)
		tlw:SetDimensions(px, px)
		tlw:SetHidden(false)
		tlw:SetAlpha(0)
	local bd = WINDOW_MANAGER:CreateControlFromVirtual("SorcererHelper"..name.."BD", tlw, "ZO_DefaultBackdrop")
		bd:SetAlpha(1)
	local icon = WINDOW_MANAGER:CreateControl("SorcererHelper"..name.."Icon", tlw, CT_TEXTURE)
		icon:SetDimensions(px+10,px+10)
		icon:SetAnchor(CENTER, tlw, CENTER, 0, 0)
		icon:SetTexture(SH.Icons[1])
		icon:SetDrawLevel(1)
	local text = WINDOW_MANAGER:CreateControl("SorcererHelper"..name.."Text", tlw, CT_LABEL)
		text:SetDimensions(px+10,px+10)
		text:SetVerticalAlignment(1)
		text:SetHorizontalAlignment(1)
		text:SetScale(2.5)
		text:SetAnchor(CENTER, tlw, CENTER, 0, 0)
		text:SetAlpha(1)
		text:SetFont("ZoFontGame")
        text:SetColor(1,0.98,0.8,1)
        text:SetStyleColor(0,0,0,1)
		text:SetDrawLevel(2)
	return tlw,bd,icon,text
end

function SH.CreateUI()
	if not SH.BuffBarWindow then
		SH.BuffBarWindow = WINDOW_MANAGER:CreateTopLevelWindow("SorcererHelperBuffBarWindow")
		SorcererHelperBuffBarWindow:SetDimensions(121, 28)
		SorcererHelperBuffBarWindow:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, SH.SV.BBx, SH.SV.BBy)
		SorcererHelperBuffBarWindow:SetHidden(false)
		SorcererHelperBuffBarWindow:SetMovable(true)
		SorcererHelperBuffBarWindow:SetMouseEnabled(true)
		SorcererHelperBuffBarWindow:SetAlpha(0)
		SorcererHelperBuffBarWindow:SetHandler("OnMouseUp", function(_, button)
			if button == 1 then
				SH.SV.BBx = math.floor(SorcererHelperBuffBarWindow:GetLeft())
				SH.SV.BBy = math.floor(SorcererHelperBuffBarWindow:GetTop())
			end
		end)

		SH.BuffBarWindowBD = WINDOW_MANAGER:CreateControlFromVirtual("SorcererHelperBuffBarWindowBD", SH.BuffBarWindow, "ZO_DefaultBackdrop")
		SorcererHelperBuffBarWindowBD:SetAnchor(TOPLEFT, SH.BuffBarWindow, TOPLEFT, -12, -12 )
    	SorcererHelperBuffBarWindowBD:SetInheritAlpha(false)
    	SorcererHelperBuffBarWindowBD:SetAlpha(0)
	end

	if not SH.AlertBarWindow then
		SH.AlertBarWindow = WINDOW_MANAGER:CreateTopLevelWindow("SorcererHelperAlertBarWindow")
		SorcererHelperAlertBarWindow:SetDimensions(64, 64)
		SorcererHelperAlertBarWindow:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, SH.SV.ABx, SH.SV.ABy)
		SorcererHelperAlertBarWindow:SetHidden(false)
		SorcererHelperAlertBarWindow:SetMovable(true)
		SorcererHelperAlertBarWindow:SetMouseEnabled(true)
		SorcererHelperAlertBarWindow:SetAlpha(0)
		SorcererHelperAlertBarWindow:SetHandler("OnMouseUp", function(_, button)
			if button == 1 then
				SH.SV.ABx = math.floor(SorcererHelperAlertBarWindow:GetLeft())
				SH.SV.ABy = math.floor(SorcererHelperAlertBarWindow:GetTop())
			end
		end)

		SH.AlertBarWindowBD = WINDOW_MANAGER:CreateControlFromVirtual("SorcererHelperAlertBarWindowBD", SH.AlertBarWindow, "ZO_DefaultBackdrop")
		SorcererHelperAlertBarWindowBD:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, -12, -12 )
    	SorcererHelperAlertBarWindowBD:SetInheritAlpha(false)
    	SorcererHelperAlertBarWindowBD:SetAlpha(0)
	end

	if not SH.SummonWindow1 then
		SH.SummonWindow1, SH.SummonWindow1BD, SH.SummonWindow1Icon = SH.CreateBuffWindow("SummonWindow1",22)
		SH.SummonWindow1Icon:SetTexture(SH.Icons[1])
	end

	if not SH.SummonWindow2 then
		SH.SummonWindow2, SH.SummonWindow2BD, SH.SummonWindow2Icon = SH.CreateBuffWindow("SummonWindow2",22)
		SH.SummonWindow2Icon:SetTexture(SH.Icons[2])
	end
	
	if not SH.MLWindow then
		SH.MLWindow, SH.MLWindowBD, SH.MLWindowIcon = SH.CreateBuffWindow("MLWindow",22)
		SH.MLWindowIcon:SetTexture(SH.Icons[4])
	end

	if not SH.BAWindow then
		SH.BAWindow, SH.BAWindowBD, SH.BAWindowIcon = SH.CreateBuffWindow("BAWindow",22)
		SH.BAWindowIcon:SetTexture(SH.Icons[8])
	end

	if not SH.CFProcWindow then
		SH.CFProcWindow, SH.CFProcBD, SH.CFProcIcon, SH.CFProcWindowText = SH.CreateBuffWindow("CFProcWindow", 54)
		SH.CFProcIcon:SetTexture(SH.Icons[3])
	end

	if not SH.SurgeWindow then
		SH.SurgeWindow, SH.SurgeWindowBD, SH.SurgeWindowIcon, SH.SurgeWindowText = SH.CreateBuffWindow("SurgeWindow", 54)
		SH.SurgeWindowIcon:SetTexture(SH.Icons[5])
	end

	if not SH.LFWindow then
		SH.LFWindow, SH.LFWindowBD, SH.LFWindowIcon, SH.LFWindowText = SH.CreateBuffWindow("LFWindow", 54)
		SH.LFWindowIcon:SetTexture(SH.Icons[6])
	end

	if not SH.EHWindow then
		SH.EHWindow, SH.EHWindowBD, SH.EHWindowIcon, SH.EHWindowText = SH.CreateBuffWindow("EHWindow", 54)
		SH.EHWindowIcon:SetTexture(SH.Icons[7])
	end

	if not SH.CurseWindow then
		SH.CurseWindow, SH.CurseWindowBD, SH.CurseWindowIcon, SH.CurseWindowText = SH.CreateBuffWindow("CurseWindow", 54)
		SH.CurseWindowIcon:SetTexture(SH.Icons[9])
	end
end
-----------------------------------------------------
function SH.FadeIn(control)
	if control:GetAlpha() == 1 then return end
	local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = control:GetAnchor()
	local timeline = ANIMATION_MANAGER:CreateTimeline()
 	
 	local popin = timeline:InsertAnimation(ANIMATION_SCALE, control)
    popin:SetScaleValues(0, 1)
    popin:SetDuration(500)
    popin:SetEasingFunction(SH.CustomEasing)
 
    local fadeIn = timeline:InsertAnimation(ANIMATION_ALPHA, control)
    fadeIn:SetAlphaValues(0, 1)
    fadeIn:SetDuration(150)
    fadeIn:SetEasingFunction(ZO_EaseOutQuadratic)

    timeline:SetHandler('OnStop', function()
        control:ClearAnchors()
        control:SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
    end)
 
    timeline:PlayFromStart()
end

function SH.FadeOut(control)
	if control:GetAlpha() == 0 then return end
	local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = control:GetAnchor()
 	local timeline = ANIMATION_MANAGER:CreateTimeline()
 
    local popout = timeline:InsertAnimation(ANIMATION_SCALE, control)
    popout:SetScaleValues(1, 0)
    popout:SetDuration(1000)
    popout:SetEasingFunction(SH.CustomEasing)
 
    local fadeOut = timeline:InsertAnimation(ANIMATION_ALPHA, control)
    fadeOut:SetAlphaValues(1, 0)
    fadeOut:SetDuration(500)
    fadeOut:SetEasingFunction(ZO_EaseInQuartic)

    timeline:SetHandler('OnStop', function()
        control:ClearAnchors()
        control:SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
    end)
 
    timeline:PlayFromStart()
end
-----------------------------------------------------
function SH.KeyScanner()
	if SH.Slotted[5] == true then
		if SH.SurgeProc == true then
			local SurgeButton = _G["ActionButton"..SH.SurgeSlot.."Button"]
			if SurgeButton:GetState() == BSTATE_PRESSED then
				SH.SurgeTimer = GetSecondsSinceMidnight() + 17
			end
		end
	end
	
	if SH.Slotted[6] == true then
		if SH.LFProc == true then
			local LFButton = _G["ActionButton"..SH.LFSlot.."Button"]
			if LFButton:GetState() == BSTATE_PRESSED then
				if SH.LFMorphed then
					SH.LFTimer = GetSecondsSinceMidnight() + 8
				else
					SH.LFTimer = GetSecondsSinceMidnight() + 6
				end
			end
		end
	end

	if SH.Slotted[9] == true then
		local CurseButton = _G["ActionButton"..SH.CurseSlot.."Button"]
		if CurseButton:GetState() == BSTATE_PRESSED then
			SH.CurseProc = true
			if SH.CurseMorphed then
				SH.CurseTimer = GetSecondsSinceMidnight() + 3
			else
				SH.CurseTimer = GetSecondsSinceMidnight() + 6
			end
		end
	end

	if SH.ScanKeys == true then
		SH.ScanKeysRunning = true
		zo_callLater(function() SH.KeyScanner() end, 200)
	else
		SH.ScanKeysRunning = false
	end
end

function SH.VisualAdded(eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue)
	if unitTag ~= "player" then return end
	local time = GetSecondsSinceMidnight()
	if unitAttributeVisual == ATTRIBUTE_VISUAL_INCREASED_STAT then
		if statType == STAT_POWER and value > 20 then -- Surge
			SH.SurgeProc = true
			SH.SurgeTimer = time + 17
		elseif statType == STAT_ARMOR_RATING then -- Lightning Form
			SH.LFProc = true
			if SH.LFMorphed then
				SH.LFTimer = time + 8
			else
				SH.LFTimer = time + 6
			end
		end
	end
end

function SH.VisualRemoved(eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue)

	if unitTag ~= "player" then return end
	if unitAttributeVisual == ATTRIBUTE_VISUAL_INCREASED_STAT then
		if statType == STAT_POWER then --Surge
			SH.SurgeProc = false
		end
		if statType == STAT_ARMOR_RATING then --Lightning Form
			SH.LFProc = false
		end 
	end
end
-----------------------------------------------------
function SH.GetAbilities()
	SH.Abilities[1], SH.Icons[1] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 2, 2) -- Familiar/Clannfear
	SH.Abilities[2], SH.Icons[2] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 2, 4) -- Winged Twilight
	SH.Abilities[3], SH.Icons[3] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 1, 2) -- Crystal Fragments
	SH.Abilities[4], SH.Icons[4] = GetSkillAbilityInfo(SKILL_TYPE_GUILD, 2, 2) -- Mage's Light
	SH.Abilities[5], SH.Icons[5] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 3, 5) -- Surge
	SH.Abilities[6], SH.Icons[6] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 3, 3) -- Lightning Form
	SH.Abilities[7], SH.Icons[7] = GetSkillAbilityInfo(SKILL_TYPE_GUILD, 1, 4) -- Expert Hunter
	SH.Abilities[8], SH.Icons[8] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 2, 5) -- Bound Armor
	SH.Abilities[9], SH.Icons[9] = GetSkillAbilityInfo(SKILL_TYPE_CLASS, 2, 3) -- Daedric Curse
	if SH.Abilities[6] == GetAbilityProgressionAbilityInfo(6,1,1) then
		SH.LFMorphed = true
	else
		SH.LFMorphed = false
	end
	if SH.Abilities[9] == GetAbilityProgressionAbilityInfo(8,2,1) then
		SH.CurseMorphed = true
	else
		SH.CurseMorphed = false
	end
end

function SH.GetSlotted()
	local name
	SH.ScanKeys = false
	for slot = 1, 9 do
		SH.Slotted[slot] = false
	end
	for slot = 3, 7 do
	    name = GetSlotName(slot)
		if SH.SV.ShowSummons then
			if name == SH.Abilities[1] then
				SH.Slotted[1] = true
			end
			if name == SH.Abilities[2] then
				SH.Slotted[2] = true
			end
		end
		if SH.SV.ShowProc then
			if name == SH.Abilities[3] then
				SH.Slotted[3] = true
				SH.CFSlot = slot
			end
		end
		if SH.SV.ShowLight then
			if name == SH.Abilities[4] then
				SH.Slotted[4] = true
			end
		end
		if SH.SV.ShowSurge then
			if name == SH.Abilities[5] then
				SH.Slotted[5] = true
				SH.SurgeSlot = slot
				SH.ScanKeys = true
			end
		end
		if SH.SV.ShowLightningForm then
			if name == SH.Abilities[6] then
				SH.Slotted[6] = true
				SH.LFSlot = slot
				SH.ScanKeys = true
			end
		end
		-- Expert Hunter (experimental)
		if SH.SV.ShowExpertHunter then
			if name == SH.Abilities[7] then
				SH.Slotted[7] = true
				SH.EHSlot = slot
			end
		end
		if SH.SV.ShowBoundArmor then
			if name == SH.Abilities[8] then
				SH.Slotted[8] = true
			end
		end
		if SH.SV.ShowCurse then
			if name == SH.Abilities[9] then
				SH.Slotted[9] = true
				SH.CurseSlot = slot
			end
		end
	end
end

function SH.GetBuffs()
	SH.Buffs[1] = false
	SH.Buffs[2] = false
	SH.Buffs[4] = false
	SH.Buffs[7] = false
	SH.Buffs[8] = false
	SH.CFProc = false
	local name
    local numBuffs = GetNumBuffs("player")
	
	for buff = 1, numBuffs do
		name = GetUnitBuffInfo("player", buff)
        if SH.SV.ShowSummons then
	        if name == SH.Abilities[1] then
				SH.Buffs[1] = true
			end
			if name == SH.Abilities[2] then
				SH.Buffs[2] = true
			end
		end
		if SH.SV.ShowLight then
			if name == SH.Abilities[4] then
				SH.Buffs[4] = true
			end
		end
		if SH.SV.ShowExpertHunter then
			if name == SH.Abilities[7] then
				SH.Buffs[7] = true
			end
		end
		if SH.SV.ShowBoundArmor then
			if name == SH.Abilities[8] then
				SH.Buffs[8] = true
			end
		end
	end

	if SH.SV.ShowProc then
		if SH.Slotted[3] == true then
			local cost = GetSlotAbilityCost(SH.CFSlot)
			if cost > (SH.CFCost + 1) / 2 then 
				SH.CFCost = cost
				SH.CFTimer = GetSecondsSinceMidnight() + 8
			elseif cost <= (SH.CFCost + 1) / 2 then
				SH.CFProc = true
			else
				SH.CFProc = false
				SH.CFTimer = GetSecondsSinceMidnight() + 8
			end
		end
	end
end
-----------------------------------------------------
function SH.MainLoop()
	SH.BuffBar = 0
	SH.AlertBar = 0
	SH.GetBuffs()
	local time = GetSecondsSinceMidnight()
	local inMenu = ZO_Compass:IsHidden()
	if SH.ScanKeys == true and not SH.ScanKeysRunning then SH.KeyScanner() end

	if SH.SV.ShowSummons then
		if SH.Slotted[1] == true and SH.Buffs[1] == false and not (SH.SV.HideInMenus and inMenu) then
			SH.SummonWindow1:SetAnchor(TOPLEFT, SH.BuffBarWindow, TOPLEFT, SH.BuffBar * 39, 0)
			SH.BuffBar = SH.BuffBar + 1
			SH.FadeIn(SH.SummonWindow1)
		else
			if SH.SummonWindow1:GetAlpha() > 0 then 
				SH.FadeOut(SH.SummonWindow1)
			end
		end
		
		if SH.Slotted[2] == true and SH.Buffs[2] == false and not (SH.SV.HideInMenus and inMenu) then
			SH.SummonWindow2:SetAnchor(TOPLEFT, SH.BuffBarWindow, TOPLEFT, SH.BuffBar * 39, 0)
			SH.BuffBar = SH.BuffBar + 1
			SH.FadeIn(SH.SummonWindow2)
		else
			if SH.SummonWindow2:GetAlpha() > 0 then
				SH.FadeOut(SH.SummonWindow2) 
			end
		end
	end

	if SH.SV.ShowLight then
		if SH.Slotted[4] == true and SH.Buffs[4] == false and not (SH.SV.HideInMenus and inMenu) then
			SH.MLWindow:SetAnchor(TOPLEFT, SH.BuffBarWindow, TOPLEFT, SH.BuffBar * 39, 0)
			SH.BuffBar = SH.BuffBar + 1
			SH.FadeIn(SH.MLWindow)
		else
			if SH.MLWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.MLWindow)
			end
		end
	end

	if SH.SV.ShowBoundArmor then
		if SH.Slotted[8] == true and SH.Buffs[8] == false and not (SH.SV.HideInMenus and inMenu) then
			SH.BAWindow:SetAnchor(TOPLEFT, SH.BuffBarWindow, TOPLEFT, SH.BuffBar * 39, 0)
			SH.BuffBar = SH.BuffBar + 1
			SH.FadeIn(SH.BAWindow)
		else
			if SH.BAWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.BAWindow)
			end
		end
	end
	
	if SH.SV.ShowProc then
		if SH.Slotted[3] == true and SH.CFProc == true then
			SH.CFProcWindow:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, SH.AlertBar * 69, 0)
			SH.AlertBar = SH.AlertBar + 1
			SH.FadeIn(SH.CFProcWindow)
			SH.CFProcWindowText:SetText(SH.CFTimer - time)
		else
			if SH.CFProcWindow:GetAlpha() > 0 then
				SH.FadeOut(SH.CFProcWindow)
			end 
		end
	end

	if SH.SV.ShowSurge then
		if SH.SurgeProc == true then
			SH.SurgeWindow:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, SH.AlertBar * 69, 0)
			SH.AlertBar = SH.AlertBar + 1
			SH.FadeIn(SH.SurgeWindow)
			SH.SurgeWindowText:SetText(SH.SurgeTimer - time)
		else
			if SH.SurgeWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.SurgeWindow)
			end
		end
	end

	if SH.SV.ShowLightningForm then
		if SH.LFProc == true then
			SH.LFWindow:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, SH.AlertBar * 69, 0)
			SH.AlertBar = SH.AlertBar + 1
			SH.FadeIn(SH.LFWindow)
			SH.LFWindowText:SetText(SH.LFTimer - time)
		else
			if SH.LFWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.LFWindow)
			end
		end
	end

	if SH.SV.ShowExpertHunter then
		if SH.EHProc == true then
			SH.EHWindow:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, SH.AlertBar * 69, 0)
			SH.AlertBar = SH.AlertBar + 1
			SH.FadeIn(SH.EHWindow)
			SH.EHWindowText:SetText(SH.EHTimer - time)
		else
			if SH.EHWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.EHWindow)
			end
		end
	end

	if SH.SV.ShowCurse then
		if SH.CurseTimer - time < 0 then SH.CurseProc = false end
		if SH.CurseProc == true then
			SH.CurseWindow:SetAnchor(TOPLEFT, SH.AlertBarWindow, TOPLEFT, SH.AlertBar * 69, 0)
			SH.AlertBar = SH.AlertBar + 1
			SH.FadeIn(SH.CurseWindow)
			SH.CurseWindowText:SetText(SH.CurseTimer - time)
		else
			if SH.CurseWindow:GetAlpha() > 0 then 
				SH.FadeOut(SH.CurseWindow)
			end
		end
	end

    zo_callLater(function() SH.MainLoop() end, 1000)
end
-----------------------------------------------------
function SH.GetShowSummon()
	return SH.SV.ShowSummons
end

function SH.SetShowSummon(newValue)
	if newValue == false then
		SH.SummonWindow1:SetAlpha(0)
		SH.SummonWindow2:SetAlpha(0)
	end
	SH.SV.ShowSummons = newValue
end

function SH.GetShowLight()
	return SH.SV.ShowLight
end

function SH.SetShowLight(newValue)
	if newValue == false then
		SH.MLWindow:SetAlpha(0)
	end
	SH.SV.ShowLight = newValue
end

function SH.GetShowMove()
	return SH.SV.ShowMove
end

function SH.SetShowMove(newValue)
	if newValue == true then
		SorcererHelperBuffBarWindowBD:SetAlpha(1)
		SorcererHelperAlertBarWindowBD:SetAlpha(1)
	elseif newValue == false then
		SorcererHelperBuffBarWindowBD:SetAlpha(0)
		SorcererHelperAlertBarWindowBD:SetAlpha(0)
	end
	SH.SV.ShowMove = newValue
end

function SH.GetShowSurge()
	return SH.SV.ShowSurge
end

function SH.SetShowSurge(newValue)
	if newValue == false then
		SH.SurgeWindow:SetAlpha(0)
	end
	SH.SV.ShowSurge = newValue
end

function SH.GetShowLF()
	return SH.SV.ShowLightningForm
end

function SH.SetShowLF(newValue)
	if newValue == false then
		SH.LFWindow:SetAlpha(0)
	end
	SH.SV.ShowLightningForm = newValue
end

function SH.GetShowEH()
	return SH.SV.ShowExpertHunter
end

function SH.SetShowEH(newValue)
	if newValue == false then
		SH.EHWindow:SetAlpha(0)
	end
	SH.SV.ShowExpertHunter = newValue
end

function SH.GetShowProc()
	return SH.SV.ShowProc
end

function SH.SetShowProc(newValue)
	if newValue == false then
		SH.CFProcWindow:SetAlpha(0)
	end
	SH.SV.ShowProc = newValue
end

function SH.SetShowBoundArmor(newValue)
	if newValue == false then
		SH.BAWindow:SetAlpha(0)
	end
	SH.SV.ShowBoundArmor = newValue
end

function SH.GetShowBoundArmor()
	return SH.SV.ShowBoundArmor
end

function SH.SetShowCurse(newValue)
	if newValue == false then
		SH.CurseWindow:SetAlpha(0)
	end
	SH.SV.ShowCurse = newValue
end

function SH.GetShowCurse()
	return SH.SV.ShowCurse
end

function SH.SetHIM(newValue)
	SH.SV.HideInMenus = newValue
end

function SH.GetHIM()
	return SH.SV.HideInMenus
end

function SH.CreateSettings()
	local LAM = LibStub("LibAddonMenu-1.0")
	SH.panelID = LAM:CreateControlPanel("SorcererHelperPanel", "SorcererHelper")
	LAM:AddHeader(SH.panelID, "SorcererHelperReminders", "Reminders")
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowSummons", "Summoning abilities", nil, SH.GetShowSummon, SH.SetShowSummon)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowLight", "Mage's Light", nil, SH.GetShowLight, SH.SetShowLight)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowBA", "Bound Armor", nil, SH.GetShowBoundArmor, SH.SetShowBoundArmor)
	LAM:AddHeader(SH.panelID, "SorcererHelperAlerts", "Alerts")
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowProc", "Crystal Fragments", nil, SH.GetShowProc, SH.SetShowProc)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowSurge", "Surge", nil, SH.GetShowSurge, SH.SetShowSurge)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowLF", "Lightning Form", nil, SH.GetShowLF, SH.SetShowLF)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowCurse", "Daedric Curse", nil, SH.GetShowCurse, SH.SetShowCurse)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperShowEH", "Expert Hunter (experimental)", nil, SH.GetShowEH, SH.SetShowEH)
	LAM:AddHeader(SH.panelID, "SorcererHelperSetup", "Setup")
	LAM:AddCheckbox(SH.panelID, "SorcererHelperMove", "Show repositioning help", nil, SH.GetShowMove, SH.SetShowMove)
	LAM:AddCheckbox(SH.panelID, "SorcererHelperHIM", "Hide in menus", nil, SH.GetHIM, SH.SetHIM)
end

function SH.ClearOldSVs()
	SH.SV.SWx = nil
	SH.SV.SWy = nil
	SH.SV.CFx = nil
	SH.SV.CFy = nil
end

local function OnPlayerActivated()
	SH.ClearOldSVs()
	SH.GetAbilities()
	SH.GetSlotted()
	SH.CreateUI()
	SH.MainLoop()
end

local function OnAbilitySlotted(newAbility)
	--workaround for EVENT_ACTION_SLOT_ABILITY_SLOTTED firing too fast
	zo_callLater(function() SH.GetSlotted()	end, 300)
end

local function OnAddOnLoaded(eventCode, addOnName)
	if (addOnName == "SorcererHelper") then
		if GetUnitClassId("player") ~= 2 then
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_ADD_ON_LOADED)
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_PLAYER_ACTIVATED)
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_ACTION_SLOT_ABILITY_SLOTTED)
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_ACTIVE_WEAPON_PAIR_CHANGED)
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_UNIT_ATTRIBUTE_VISUAL_ADDED)
			EVENT_MANAGER:UnregisterForEvent("SorcererHelper", EVENT_UNIT_ATTRIBUTE_VISUAL_REMOVED)
			do return end
		else
			SH.SV = ZO_SavedVars:NewAccountWide("SorcererHelper_SavedVariables", 1, nil, SH.Defaults)
			SH.CreateSettings()
		end
	end
end

function SorcererHelperInitialize()
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_ADD_ON_LOADED, OnAddOnLoaded)
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_PLAYER_ACTIVATED, OnPlayerActivated)
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_ACTION_SLOT_ABILITY_SLOTTED, OnAbilitySlotted)
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_ACTIVE_WEAPON_PAIR_CHANGED, SH.GetSlotted)
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_UNIT_ATTRIBUTE_VISUAL_ADDED, SH.VisualAdded)
	EVENT_MANAGER:RegisterForEvent("SorcererHelper", EVENT_UNIT_ATTRIBUTE_VISUAL_REMOVED, SH.VisualRemoved)
end